/* CKagiModuleLoader */

#import <Cocoa/Cocoa.h>

@interface CKagiModuleLoader : NSObject


enum {

    //MODULE STATUS CODES...

    kCKagiModuleStatusUnknownException			=-10000,

    kCKagiModuleStatusMissingLangFile			=-1100,
    kCKagiModuleStatusNullInitializationData		=-1200,
    kCKagiModuleStatusUnableToObtainKagiData		=-1210,
    kCKagiModuleStatusExceptionParsingInitData		=-1220,
    kCKagiModuleStatusInitDataLacksProductElement	=-1230,
    kCKagiModuleStatusExceptionParsingKagiData		=-1240,
    kCKagiModuleStatusKagiDataIsExpired			=-1400,
    
    kCKagiModuleStatusReadyForInvocation		=0,
    
    kCKagiModuleStatusModuleInvoked			=1000,
    kCKagiModuleStatusUserInterfaceActive		=2000,
    kCKagiModuleStatusAttemptingConnection		=3000,
    kCKagiModuleStatusConnectionSuccessful		=4000,
    kCKagiModuleStatusUserCanceledConnection		=4500,
    kCKagiModuleStatusNoFurtherRetries			=5000,
    kCKagiModuleStatusUserInterfaceClosed		=6000,
        
    
    //SERVER CONNECTION STATUS CODES...
    
    kCKagiConnectionStatusInvalidURL			=-700,
    kCKagiConnectionStatusConnectionTimeout		=-600,
    kCKagiConnectionStatusOtherConnectionException	=-500,
    kCKagiConnectionStatusNullResponseContent		=-400,
    kCKagiConnectionStatusApplicationUnavailable	=-300,
    kCKagiConnectionStatusMalFormedResponseData		=-200,
    kCKagiConnectionStatusConnectionSuccessful		=100,
        
    
    //TRANSACTION STATUS CODES...
    
    kCKagiTransactionStatusDeniedDuplicate		=1000,
    kCKagiTransactionStatusDeniedNoCharge		=2000,
    kCKagiTransactionStatusExceptionCertainCharge	=3000,
    kCKagiTransactionStatusExceptionPossibleCharge	=4000,
    kCKagiTransactionStatusSuccessCertainCharge		=5000
        
};

-(id)init;

-(void)initializeWithSuppliedData:(NSString *)suppliedData;

-(void)registerForNotification:(NSObject *)anObserver withSelector:(SEL)aSelector;

- (NSString *)getNotificationName;

- (NSString *)getVersionInfo;

- (void)setDebugEnabled:(BOOL)debugEnabled;

- (void)setFirstName:(NSString *)value;

- (void)setLastName:(NSString *)value;

- (void)setEmail:(NSString *)value;

- (void)setCardType:(NSString *)value;

- (void)setStreet1:(NSString *)value;

- (void)setStreet2:(NSString *)value;

- (void)setCity:(NSString *)value;

- (void)setStateProvince:(NSString *)value;

- (void)setZipPostal:(NSString *)value;

- (void)setCountryCode:(NSString *)value;

- (void)setReceiptOption:(NSString *)value;

- (void)setLangCode:(NSString *)value;

- (void)setCurrencyCode:(NSString *)value;

- (void)setOrderPassThroughData:(NSString *)value;

- (void)setPurchaseOrderNumber:(NSString *)value;

- (void)setAffiliateTrackingData:(NSString *)value;

- (void)setACGDictionary:(NSDictionary *)value;

- (void)setURLTimeout:(int)value;

- (void)setInitDataTimeout:(int)value;

- (void)setTransactionTimeout:(int)value;

- (void)setAllowDownloadOfLangData:(BOOL)value;
    
- (void)setLangTimeout:(int)value;

- (void)setUseFloatingPanel:(BOOL)value;

- (void)setUseVerboseConnection:(BOOL)value;

- (void)setUseDualNames:(BOOL)value;

- (void)setShowRegcodeToUser:(BOOL)value;

- (void)setConnectionLimit:(int)value;

- (int)getModuleStatus;

- (int)getConnectionStatus;

- (int)getConnectionCount;
    
- (void)invokeUserInterface;

- (BOOL)windowIsOpen;

- (void)terminateUserInterface:(BOOL)sendNotification;

- (int)getTransactionStatus;

- (NSString *)getTransactionKey;

- (NSString *)getKagiTransactionID;

- (NSString *)getUsername;

- (NSString *)getRegcode;

- (NSString *)getXMLContent;

- (NSDictionary *)getDictionary;

@end